<?php
  include("./config.php");
  include("./rcon_net.php");

  //neues Template erzeugen
  include("./template.inc");
  $tpl = new Template($templatedir, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "publicinfo" => "publicinfo.ihtml",
    "messages" => "messages.ihtml"
  ));
  
  //Blocks definieren
  $tpl->set_block("publicinfo", "player", "PLAYER");
  $tpl->set_block("publicinfo", "connectingplayer", "CONNECTINGPLAYER");
  $tpl->set_block("publicinfo", "playerlist", "PLAYERLIST");
  $tpl->set_block("messages", "notconnected", "NOTCONNECTED");
    

  //set global output
  $tpl->set_var(array(
    "TEMPLATEDIR" => $templatedir,
    "CONNECTINGPLAYER" => ""
  ));
    

  //connect to current server
  $fp = net_connect($server_ip, $server_port);

  //Not connected error
  if(!$fp)
  {
    $tpl->parse("OUT", "notconnected", false);
    $tpl->p("OUT");
    exit;
  }

  //send "info" command to current server
  $info = net($fp, "info", $server_password);

  //send "players" command to current server
  $players = net($fp, "players", $server_password);

  //close connection
  fclose($fp);


  //get global server info
  $line = explode("\x00", $info);

  //get players count (active and max)
  $player_count = explode("\n", $line[5]);

  //set global server info
  $tpl->set_var(array(
    "TCPIP" => $line[0],
    "HOSTNAME" => $line[1],
    "MAP" => $line[2],
    "PLAYERS" => $player_count[1] . " active (" . $player_count[2] . " max)"
  ));


  //get player info
  $line = explode("\n", $players);
  
  for($i = 1; $i <= $line[0]; $i++)
  {
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";
  
    //get player data    
    $playerline = explode("\t", $line[$i]);
    
    //parse player info
    $tpl->set_var(array(
      "ROWSTYLE" => $row,
      "NUMBER" => $playerline[0],
      "NAME" => $playerline[1],
      "FRAG" => $playerline[2]
    ));
    
    $tpl->parse("PLAYER", "player", true);
    
  } //for($i = 1; $i <= $line[0]; $i++)

  //display connecting players
  for($i = $line[0]; $i < $player_count[1]; $i++)
  {
    //toggle row color  
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";
  
    //parse connecting players
    $tpl->set_var(array(
      "ROWSTYLE" => $row,
      "NUMBER" => $i
    ));
    
    $tpl->parse("CONNECTINGPLAYER", "connectingplayer");
  } //for($i = $line[0]; $i <= $player_count[1]; $i++)

  //parse Playerlist
  if($player_count[1] > 0)
    $tpl->parse("PLAYERLIST", "playerlist");
  else
    $tpl->set_var("PLAYERLIST", "");

  //parse everything and print it
  $tpl->parse("OUT", "publicinfo");
  $tpl->p("OUT");

?>