<?php
  include("./config.php");
  include("./security.php");
  
  include("./rcon_net.php");

  //neues Template erzeugen
  include("./template.inc");
  $tpl = new Template($templatedir, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "messages" => "messages.ihtml",
    "helptext" => "helptext.ihtml",
    "serverbanlist" => "serverbanlist.ihtml"
  ));
  
  //Blocks definieren
  $tpl->set_block("serverbanlist", "row", "ROWS");
  $tpl->set_block("messages", "notconnected", "NOTCONNECTED");
  $tpl->set_block("messages", "badrcon", "BADRCON");
  $tpl->set_block("helptext", "banlist", "BANLIST");

  //parse helptext
  $tpl->set_var(array(
    "TEMPLATEDIR" => $templatedir,
  ));
  if($helptext == 1)
    $tpl->parse("HELP", "banlist", false);
  else
    $tpl->set_var("HELP", "");


  //build connection to Apachenpub
  $fp = net_connect ($server_ip, $server_port);

  //Not connected error
  if(!$fp)
  {
    $tpl->parse("CONTENT", "notconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }
  
  //show banned id list
  $banlist = net($fp, "listid", $server_password);

  //close connection
  fclose($fp);

  //Bad rcon password
  if(trim($banlist) == "Bad rcon_password.")
  {
    $tpl->parse("CONTENT", "badrcon", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }
 

  //output
  $line = explode("\n", $banlist);
  $count = sizeof($line);

  for($i = 1; $i < ($count - 1); $i++)
  {
    $tmp = explode(":", $line[$i]);

    //toggle row color
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";
    
    $tpl->set_var(array(
      "ROWSTYLE" => $row,
      "WONID" => $tmp[0],
      "TIMEFRAME" => $tmp[1]
    ));
   $tpl->parse("ROWS", "row", true);
    
  } //for($i = 1;$i < ($count - 1); $i++)


  //parse content in main template
  $tpl->parse("CONTENT", "serverbanlist", false);

  //parse everything and print it
  $tpl->parse("OUT", "main", false);
  $tpl->p("OUT");

?>
