<?php
  include("./config.php");
  include("./security.php");
  include("./rcon_net.php");

  //neues Template erzeugen
  include("./template.inc");
  $tpl = new Template($templatedir, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "messages" => "messages.ihtml",
    "helptext" => "helptext.ihtml",
    "serverinfo" => "serverinfo.ihtml"
  ));
  
  //Blocks definieren
  $tpl->set_block("serverinfo", "player", "PLAYER");
  $tpl->set_block("serverinfo", "connectingplayer", "CONNECTINGPLAYER");
  $tpl->set_block("serverinfo", "playerlist", "PLAYERLIST");
  $tpl->set_block("messages", "notconnected", "NOTCONNECTED");
  $tpl->set_block("messages", "badrcon", "BADRCON");
  $tpl->set_block("helptext", "info", "INFO");
    

  //set global output
  $tpl->set_var(array(
    "TEMPLATEDIR" => $templatedir,
    "CONNECTINGPLAYER" => ""
  ));
  if($helptext == 1)
    $tpl->parse("HELP", "info", false);
  else
    $tpl->set_var("HELP", "");
    


  //connect to current server
  $fp = net_connect($server_ip, $server_port);

  //Not connected error
  if(!$fp)
  {
    $tpl->parse("CONTENT", "notconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }

  //send "status" command to current server
  $status = net($fp, "status", $server_password);

  //close connection
  fclose($fp);

  //Bad rcon password
  if(trim($status) == "Bad rcon_password.")
  {
    $tpl->parse("CONTENT", "badrcon", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }


  //get global server info
  $line = explode("\n", $status);
  $map = substr($line[3], strpos($line[3], ":") + 1);
  $players = trim(substr($line[4], strpos($line[4], ":") + 1));
  $active = explode(" ", $players);
  
  $tpl->set_var(array(
    "HOSTNAME" => trim(substr($line[0], strpos($line[0], ":") + 1)),
    "VERSION" => trim(substr($line[1], strpos($line[1], ":") + 1)),
    "TCPIP" => trim(substr($line[2], strpos($line[2], ":") + 1)),
    "MAP" => trim(substr($map, 0, strpos($map, "at:"))),
    "PLAYERS" => $players
  ));


  //get player info
  for($i = 7; $i < 7 + $active[0]; $i++)
  {
    //get possible player line
    $tmp = $line[$i];
    
    //toggle row color
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";
    
    //get player number
    $player_number = $i - 6;
    
    $tpl->set_var(array(
      "ROWSTYLE" => $row,
      "NUMBER" => $player_number
    ));


    //in case we have a player line ...
    if(substr_count($line[$i], "#") > 0)
    {
      //name
      $begin = strpos($tmp, "\"") + 1;
      $end = strrpos($tmp, "\"");
      $name = substr($tmp, $begin, $end - $begin);
      $tmp = trim(substr($tmp, $end + 1));
  
      //ID
      $end = strpos($tmp, " ");
      $id = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //WonID
      $end = strpos($tmp, " ");
      $wonid = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //Frag
      $end = strpos($tmp, " ");
      $frag = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //Time
      $end = strpos($tmp, " ");
      $time = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //Ping
      $end = strpos($tmp, " ");
      $ping = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //Loss
      $end = strpos($tmp, " ");
      $loss = substr($tmp, 0, $end);
      $tmp = trim(substr($tmp, $end));
        
      //Adress
      $adress = $tmp;
        
        
      $tpl->set_var(array(
        "NAME" => $name,
        "ID" => $id,
        "WONID" => $wonid,
        "FRAG" => $frag,
        "TIME" => $time,
        "PING" => $ping,
        "LOSS" => $loss,
        "ADRESS" => $adress
      ));
      
      $tpl->parse("PLAYER", "player", true);
    }
    else
      $tpl->parse("PLAYER", "connectingplayer", true);

  } //for($i = 7; $i < 7 + $active[0]; $i++)

  //check if there are any players online
  if($i > 7)
    $tpl->parse("PLAYERLIST", "playerlist", false);
  else
    $tpl->set_var("PLAYERLIST", "");
    

  //parse content in main template
  $tpl->parse("CONTENT", "serverinfo", false);

  //parse everything and print it
  $tpl->parse("OUT", "main");
  $tpl->p("OUT");

?>