<?php
  include("./config.php");
  include("./security.php");
  
  include("./rcon_net.php");

  //neues Template erzeugen
  include("./template.inc");
  $tpl = new Template($templatedir, "keep");

  //Files bekannt machen
  $tpl->set_file(array(
    "main" => "main.ihtml",
    "messages" => "messages.ihtml",
    "helptext" => "helptext.ihtml",
    "servermaps" => "servermaps.ihtml"
  ));
  
  //Blocks definieren
  $tpl->set_block("servermaps", "map", "MAP");
  $tpl->set_block("servermaps", "dir", "DIR");
  $tpl->set_block("messages", "notconnected", "NOTCONNECTED");
  $tpl->set_block("messages", "badrcon", "BADRCON");
  $tpl->set_block("helptext", "maps", "MAPS");

  //parse helptext
  $tpl->set_var(array(
    "TEMPLATEDIR" => $templatedir,
    "MAP" => "",
    "DIR" => ""
  ));
  if($helptext == 1)
    $tpl->parse("HELP", "maps", false);
  else
    $tpl->set_var("HELP", "");


  //connect to current server
  $fp = net_connect($server_ip, $server_port);
  
  //Not connected error
  if(!$fp)
  {
    $tpl->parse("CONTENT", "notconnected", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }

  //send "rules" command to current server
  $maps = net($fp, "maps *", $server_password);

  //close connection
  fclose($fp);

  //Bad rcon password
  if(trim($maps) == "Bad rcon_password.")
  {
    $tpl->parse("CONTENT", "badrcon", false);
    $tpl->parse("OUT", "main", false);
    $tpl->p("OUT");
    exit;
  }
 
    
  //Do all output stuff
  $line = explode("\n", $maps);
  $count = sizeof($line) - 4;

  for($i = 1; $i <= $count; $i++)  
  {
    //toggle row color
    if($row == "row_one")
      $row = "row_two";
    else
      $row = "row_one";

    $text = $line[$i];
    
    if(strstr($text, "Dir:"))
    {
      $directory = strstr($text, " ");
      $tpl->set_var("DIRECTORY" , $directory);
      $tpl->parse("ROWS", "dir", true);
    }
    else if(strstr($text, "(fs)"))
    {
      $mappath = strstr($text, " ");
      $mapname = strrchr($mappath, "/");
      $mapname = substr($mapname, 1, strpos($mapname, ".") - 1);
      $command = urlencode("changelevel $mapname");

      $tpl->set_var(array(
        "ROWSTYLE" => $row,
        "MAPPATH" => $mappath,
        "MAPNAME" => $mapname,
        "COMMAND" => $command
      ));
      $tpl->parse("ROWS", "map", true);
      
    }

  } //for($i = 1; $i <= $count; $i++)  

  //parse content in main template
  $tpl->parse("CONTENT", "servermaps", false);

  //parse everything and print it
  $tpl->parse("OUT", "main", false);
  $tpl->p("OUT");

?>
